(* CSE505, Homework 5 *)

type field = string * (obj ref)
and  meth  = string * (obj -> obj list -> obj)
and  obj   = O of (field list) * (meth list)
           | N of float

exception Unimplemented
exception ObjectExpected
exception IntExpected
exception FieldNotFound of string * obj
exception MethodNotFound of string * obj

let fields (obj : obj) =
  match obj with
    O(fs,_) -> fs
  | N _ -> raise ObjectExpected
let methods (obj : obj) =
  match obj with
    O(_,ms) -> ms
  | N _ -> raise ObjectExpected
let num (obj : obj) =
  match obj with
    N n -> n
  | O _ -> raise IntExpected

let newObj () : obj = O([],[])

let get (s : string) (obj : obj) : obj = raise Unimplemented

let set (s : string) (obj : obj) (v : obj) : unit = raise Unimplemented

let findAndSend (s : string) (rcvr : obj) (ms : meth list) (args : obj list) =
  raise Unimplemented

let send (s : string) (rcvr : obj) (args : obj list) = raise Unimplemented

let getter s = raise Unimplemented
let setter s = raise Unimplemented
  
let newPoint (x : obj) (y : obj) : obj =
  let super = newObj () in
  let fs = ("x",ref x)::("y",ref y)::(fields super)in
  let distToOrigin1 this args =
    let n1 = num (get "x" this) in
    let n2 = num (get "y" this) in
    N (sqrt ((n1 *. n1) +. (n2 *. n2))) in
  let ms = ("getX",getter "x")
           ::("getY",getter "y")
           ::("setX",setter "x")
           ::("setY",setter "y")
           ::("distToOrigin1",distToOrigin1)
           ::(methods super) in
  O(fs,ms)

let newPoint3D (x : obj) (y : obj) (z : obj) : obj = raise Unimplemented

let toPolar x y = (* return (r,theta) *)
  (sqrt ((x *. x) +. (y *. y)),
   atan (y /. x))
let toCartesian r theta = (* return (x,y) *)
  (r *. (cos theta),
   r *. (sin theta))

let newPolarPoint (x : obj) (y : obj) : obj = raise Unimplemented

let newPolarPointB (x : obj) (y : obj) : obj = raise Unimplemented

(* testing *)
let printNum obj = print_string (string_of_float (num obj)); print_newline()

(*
let p1 = newPoint (N 3.0) (N 4.0)
let _ = printNum (send "distToOrigin1" p1 [])
let _ = printNum (send "distToOrigin2" p1 [])
let _ = (send "setY" p1 [N 3.0])
let _ = printNum (send "distToOrigin1" p1 [])
let _ = printNum (send "distToOrigin2" p1 [])

let p2 = newPoint3D (N 0.0) (N 4.0) (N 3.0)
let _ = printNum (send "distToOrigin1" p2 [])
let _ = printNum (send "distToOrigin2" p2 [])
let _ = printNum (send "distToOrigin3" p2 [])
let _ = (send "setY" p2 [N 3.0])
let _ = printNum (send "distToOrigin1" p2 [])
let _ = printNum (send "distToOrigin2" p2 [])
let _ = printNum (send "distToOrigin3" p2 [])

let p3 = newPolarPoint (N 3.0) (N 4.0)
let _ = printNum (send "distToOrigin1" p3 [])
let _ = printNum (send "distToOrigin2" p3 [])
let _ = (send "setY" p3 [N 3.0])
let _ = printNum (send "distToOrigin1" p3 [])
let _ = printNum (send "distToOrigin2" p3 [])

let p4 = newPolarPointB (N 3.0) (N 4.0)
let _ = printNum (send "distToOrigin1" p4 [])
let _ = printNum (send "distToOrigin2" p4 [])
let _ = (send "setY" p4 [N 3.0])
let _ = printNum (send "distToOrigin1" p4 [])
let _ = printNum (send "distToOrigin2" p4 [])
*)
